#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
#-------------------------------------------------------------------------
#    Name:  dbamon_kb
#
# Version:  @(#)$Revision$
#
# Purpose:  
#
#   Specs: 
#
#  Author:  Bill Border
#-------------------------------------------------------------------------
$| = 1;
$P = "dbamon_kb.pl";
$DBAmonforms = "/dbamon4/forms/";
$numrcvrs = 40;
$rowcolor = "b0e0e6";
$table_header_color = "navyblue"; 

$font = "arial" if ! $font;
chop($CurrentDate = `date`);

$verb = $ARGV[0];

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

use DBI;
require "cgi_handlers.pl";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#------------------------------------------------------------------------------
sub Include
#------------------------------------------------------------------------------
{
  $file = $_[0];
  open (FILE, "$file") || die ("Can't open input file $file");
  while ($line = <FILE>) 
  {
    print $line;
  }
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff";
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=$rowcolor";
  }
}


#-----------------------------------------------------------------------------
sub displayError 
{
   local($errorMsg,@error_fields) = @_;

   #print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body></table>";

   print "<p>";
   print "<h3> A Database Error Has Occured:</h3>";
 print "<h4>$errorMsg</h4>";
 print "SQL statement: <pre>$statement</pre>";
 print "Error: <pre>$DBI::errstr</pre>";

 &PrintLinks;

 print "</body>";
 print "</html>";


 if ($entLocked) { close(ENTLOCKFILE); unlink($entlockfile); }
 if ($conLocked) { close(CONLOCKFILE); unlink($conlockfile); }
 if ($dbLocked)  { &unlockDb; }

 exit(1);
}

#-----------------------------------------------------------------------------
sub errorCheck
{
  ##print "f-system=$f{'system'}\n";

  if ($rqpairs{'i_title'} eq "") {push (@error_list, "Title must not be blank\n");}
  if ($rqpairs{'i_text'}  eq "") {push (@error_list, "Text must not be blank\n");}
}

#-----------------------------------------------------------------------------
sub IntHandler
{
 local($Signal) = @_;
 close(you_fill_in_the_file_descriptor);
 unlink($you_fill_in_the_tmp_file_name);
 exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
{
 $manyerrors = @error_list;
 $str= "" ;
 $str1="";
 $str4="<h3>Insufficient or missing information...</h3><hr>";
 $html_str=$str.$str1.$str2.$str1.$str4;
 print "$html_str\n";
 print "<h4>Please correct the following:</h4>";
 print "<p>\n";
 print "<ul>\n";
 foreach( @error_list) 
 {
    print "<li> $_\n<br>";
 }
 print "</ul>\n";
 if ($manyerrors > 3) {
    print "$manyerrors errors - Having a bad day, are we?<p>\n";
 }
 else {
    print "$manyerrors correction(s) to make.<p>\n";
 }
 print "<hr>Click <b>BACK</b> and try again.\n";
    
}


#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
# Connect to the Mysql database
$dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
       &error('Failed_on_DB_connect_in_updateDb');
}


#-----------------------------------------------------------------------------
sub EnterBuild
#-----------------------------------------------------------------------------
{
  print "
  <P><FORM method='POST' action='/cgi-bin/${P}?EnterProcess'>
  <font size=2>This transaction is used to create a new KB entry. Enter
    the title and text for this KB entry and click <b>Save</b> at the
    bottom of the form.
  <p>
  <hr>
  \n";

  print"
    <font size=2><b>KB Entry Title: </b>
    <INPUT type=text size=80 maxlength=80 name=i_title value=$i_distlist>
    <p><font size=2><b>KB Text: </b> 
    <br><TEXTAREA NAME='i_text' COLS=120 ROWS=24 WRAP='off'>
    </TEXTAREA>
  ";

    print " <HR>
  <p><b>
  <INPUT type=submit value=' Save '>
  <INPUT type=reset  value=' Clear Form '></b>
  </form></form>";
}


#-----------------------------------------------------------------------------
sub UpdateBuild
#-----------------------------------------------------------------------------
{

  &selectText;
  &msg("Data for KB Entry: $entry"); 

  print "
  <P><FORM method='POST' action='/cgi-bin/${P}?EnterProcess'>
    <span $style_normal >
    This transaction is used to update an existing KB entry. Update
    the desired fields and click <b>Save</b>.<p>
  ";

  print"<span $style_normal>
  <p><b>
  <INPUT type=submit value=' Save '>
  <INPUT type=reset  value=' Clear Form '></b>
    <p><b>KB Entry Title: <br>
    <span STYLE='font-size: 9pt;font-face:consolas;' >
    <INPUT type=text size=80 maxlength=80 name=i_title value='$title' STYLE='background:linen;font-size:10pt;font-face:consolas;'>
    <p><font size=2><b>KB Text: </b> 
    <br><TEXTAREA NAME='i_text' STYLE='background:linen;font-size: 9pt;font-face:consolas;' COLS=120 ROWS=24 WRAP='physical'>
$alltext
    </TEXTAREA>
  ";

    print " 
  <p><b>
  <INPUT type=submit value=' Save '>
  <INPUT type=reset  value=' Clear Form '></b>
  </form></form>";
}

#-----------------------------------------------------------------------------
sub Browse
#-----------------------------------------------------------------------------
{
  # Create the SQL SELECT statement

  if ($dbamon_repos eq "O")
  {
    $statement  = "select 
      instance,
      text,
      to_char(ts,'YYYY/MM/DD-HH24:MI:SS')
    from 
      text
    where
      system = '-KB-'
      and seq = 0
    order by
      1";
  }
  else
  {
    $statement  = "select 
      instance,
      text,
      --to_char(ts,'YYYY/MM/DD-HH24:MI:SS')
      dbamon.dateconvert_19(ts)
    from 
      dbamon.text
    where
      system = '-KB-'
      and seq = 0
    order by
      1";
  }

  #print "statement=$statement\n";

  $sth = $dbh->prepare($statement) ||
	  &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  # Create table
  ##print "
  ##<span $style_large >KB Entries: </span>
  &msg("KB Entries:"); 
  print "
  <p><table border=0 $style_normal bgcolor=wheat width=80%>
  ";

  #print "<tr bgcolor=lightgrey> <td nowrap align=center colspan=99> 
  #         <a href=\"/cgi-bin/${P}?EnterBuild\"><font size=2><b>Create New KB Entry</a> 
  #\n";
  #print "<tr bgcolor=lightgrey> <td nowrap align=center colspan=99> 
  #         <a href=\"/cgi-bin/dbamon_text_search.pl\">Search KB</a> 
  #\n";

  print "<tr bgcolor=$table_header_color>
    <th $style_normal>Menu:
    <th  $style_normal rowspan=3>KB Entry Title
    <th $style_normal rowspan=3>Last Updated
    <th  $style_normal rowspan=3>KB Entry ID
      </font>\n";

  print "<tr zgcolor=lightgrey>
    <td nowrap align=center $style_normal> <a href=\"/cgi-bin/${P}?EnterBuild\"> <b> Create New KB Entry </b> </a> \n";
  print "<tr zgcolor=lightgrey> 
    <td nowrap align=center $style_normal> <a href=\"/cgi-bin/dbamon_text_search.pl\"> <b> Search KB </b> </a> \n";

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $entry   = $Data[0];
    $title   = $Data[1];
    $ts      = $Data[2];

    $bg = &bgRow;
    print "
    <tr $bg >
      <td align=center $style_normal>
      <a href='/cgi-bin/${P}?UpdateBuild/$entry'><b>Browse/Update</b></a> | 
      <a href=\"/cgi-bin/${P}?Delete/$entry\"><b>Delete</b></a>
    <td width=60% $style_normal> <b> $title </b>
    <td $style_normal>$ts
    <td $style_normal>$entry
    "; 
  }

  print "<tr bgcolor=$table_header_color><td colspan=5 $style_normal> &nbsp; "; 
  print "</table>\n";
  
  &msg("Selected $selectcount row(s)"); 
  ##print "highkey=$highkey newkey=$newkey\n";

}


#-----------------------------------------------------------------------------
sub custom_html 
{
   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#
# Attempt to make sure that no meta characters are entered in the form.
#
#-----------------------------------------------------------------------------
sub CheckForEvilness
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
sub deleteData
{
  &msg("About to delete KB entry -KB- $entry");

  $statement  = "
  delete 
    from dbamon.text 
    where system = \'-KB-\'
    and instance = \'$entry\'";
  ##print "SQL statement=$statement\n";

  #system("id");

  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');

  &msg("Delete successful");
}

#-----------------------------------------------------------------------------
sub insertTextArray
{
  $insertcnt = 0;

  $statement  = "insert into dbamon.text (system,instance,text,seq) values ";
  $statement .= "(\'-KB-\', \'$key\', \'$i_title\', $insertcnt )";
  #print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');

  foreach $text (@textArray)
  {
    ##print;
    $insertkey++;
    #chop $text;

    # Remove naughty characters
    $text =~ s/'/"/g;
    ##print "text=$text\n";

    if (length($text) > 1000)
    {
      print "<br><b>ERROR:</b> Maximum line size of 1000 exceeded.<br>Click <b>Back</b> and try again.\n";
      print "<pre>$text</pre>";
      exit 1;
    }

    $statement  = "insert into dbamon.text (system,instance,text,seq) values ";
    $statement .= "(\'-KB-\', \'$key\', \'$text\', $insertkey )";
    #print "statement=$statement\n";

    $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
    $insertcnt++;
  }

  $insertkey++;
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  $text = "[$date - $insertcnt Rows Saved @ $ENV{'REMOTE_HOST'}]";
  $statement  = "insert into dbamon.text (system,instance,text,seq) values ";
  $statement .= "(\'-KB-\', \'$key\', \'$text\', $insertkey )";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  $insertcnt++;

  &msg("Inserted $insertcnt Rows Into KB Entry $key");
}


#-----------------------------------------------------------------------------
sub insertData
{
  # Read each variable and construct a SQL statement

  &msg("Inserting into DIST using distlist=$distlist");
  print "<p><table border=1>\n";
  print "<tr bgcolor=slate><th><h5>distlist<th><h5>distrcvr\n";

  for (1..$numrcvrs)
  {
    $i = $_;
    $cmd = "\$rcvr = \$rqpairs{'i_recipient_${i}'}";
    eval($cmd);
    ##print "i=$i cmd=$cmd rcvr=$rcvr\n";
    
    next if $rcvr eq "";

    print "<tr><td><h5>$distlist<td><h5>$rcvr\n";

    $statement  = "insert into dist
    (distlist,distrcvr,disttype)
    values
    (\'$distlist\', \'$rcvr\',\'A\')";

    ##print "statement=$statement\n";
    ##system("id");
    ##print "test2a\n";
    $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
    ##print "test2b rc=$rc\n";

    $insertcnt++;
  }
  print "</table>\n";
  &msg("Successfully Inserted $insertcnt Row(s)");
}

#-----------------------------------------------------------------------------
sub Delete
{
  if ($entry eq "")
  {
    print "<h3>Something is wrong - entry is blank - exiting\n";
    exit 1;
  }

  #
  # Delete this entry
  #
  &deleteData;

  &returnMessage;
}


#-----------------------------------------------------------------------------
sub EnterProcess
#-----------------------------------------------------------------------------
{
  chop($keydate = `date +%Y%m%d%H%M`);
  $key = $keydate . "-" . $$;

  $i_title  = $rqpairs{'i_title'};
  $i_text   = $rqpairs{'i_text'};
  $i_entry  = $rqpairs{'i_entry'};
  ##print "i_title=$i_title i_text=$i_text key=$key i_entry=$i_entry\n";

  if ($i_entry ne "")
  {
    $key   = $i_entry;
    $entry = $i_entry;
    $delflag = 1;
    &msg("Updating KB Entry $key");
  }
  else
  {
    $delflag = 0;
    &msg("Creating KB Entry $key");
  }

  #
  # Check for errors
  #
  &errorCheck;

  #
  # If errors found, terminate
  #
  if (@error_list != 0)
  {
    print LOG "Encountered errors\n";
    &error_html;
    &Include("/opt/dbamon4/html/inc/foot_small.html");
    exit 1;
  }

  #
  # Delete old data
  #
  &deleteData if $delflag == 1;

  # Put text into array
  @textArray = split(/\n/,$i_text);

  ##print "i_text=($i_text)\n";

  # Insert from array into table
  &insertTextArray;

  &returnMessage;
}

#-----------------------------------------------------------------------------
sub selectText
#-----------------------------------------------------------------------------
{
  # Create the SQL SELECT statement
  if ($dbamon_repos eq "O") 
  {
    $statement  = "select
       text,
       to_char(ts,'YYYY/MM/DD-HH24:MI:SS'),
       seq
     from dbamon.text where system='-KB-' and instance='$entry' order by ts, seq";
  }
  else
  {
    $statement  = "select
       text,
       --to_char(ts,'YYYY/MM/DD-HH24:MI:SS'),
       dbamon.dateconvert_19(ts),
       seq
     from dbamon.text where system='-KB-' and instance='$entry' order by ts, seq";
  }

  ##print "$statement\n";
  
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $thistext  = "$Data[0]";
    $thists    = "$Data[1]";
    $thisseq   = "$Data[2]";

    ##print "thistext=$thistext\n";

    if ($thisseq == 0)
    {
      $title = $Data[0];
    }
    else 
    {
      $alltext .= "$Data[0]\n";
    }

    $selectcount++;
  }

  $alltext .= "\n";

  ##print "(Rows Selected: $selectcount - Last Updated: $thists)<p>\n";
  &msg("Select $selectcount row(s) - Last Updated: $thists)");

  ##print "alltext=($alltext)\n";
  ##print "</pre>";
}

#-----------------------------------------------------------------------------
sub returnMessage
#-----------------------------------------------------------------------------
{
  print "<p><hr><p><font size=2>Click \n";
  print "<a href='/cgi-bin/dbamon_kb.pl'><b>Return to KB Menu</b></a>\n";
  print ".</font>\n";
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

#---- Get form data
&get_request;

#system("env > /tmp/${P}_env.txt");

#---- Make header
#print "Content-type: text/html\n\n";
#print "<head><title>DBAmon Knowledge Base</title></head> \n";
#Include("/opt/dbamon/htm/inc/head_top.html");
#print "<tr bgcolor=wheat width=750><td align=center>
#<img src='/dbamon/img/brain.jpg' width=16>    
#<font size=5>Knowledge Base (KB)</font>\n";

#---- Make header
&header("Knowledge Base (KB)"); 

&msg("Starting - verb=$verb"); 

@words = split(/\//,$verb);
if ($#words > 0)
{
  $verb     = @words[0];
  $entry    = @words[1];
  ##print "#=$#words verb=$verb entry=$entry\n";
}

$SaveFile = "/tmp/$P.log";
unlink($SaveFile);
open(LOG, ">>$SaveFile" );
print LOG "$P | $CurrentDate : filename=$filename\n";

#
# Connect to DB
#
&connectDB;

$verb = "Browse" if $verb eq "";
#system("echo '' | mailx -s 'monitor--$P $verb ($ENV{'REMOTE_HOST'}) [AUTO]' border\@dba.it.thecompany.com");

if ($verb eq "Browse")
{
  &Browse;
}
elsif ($verb eq "EnterBuild")
{
  &EnterBuild;
}
elsif ($verb eq "EnterProcess")
{
  &EnterProcess;
}
elsif ($verb eq "Delete")
{
  &Delete;
}
elsif ($verb eq "UpdateBuild")
{
  &UpdateBuild;
}
else
{
  print "<h3>Unknown verb=$verb\n";
}

#
# Footer 
#
Include("/opt/dbamon/htm/inc/foot_small.html");

#
# Go away
#

close(LOG);
exit 0;
