#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_histread.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$| = 1;
$P = "dbamon_ora_histread.pl";
$tmpfl = "/opt/dbasas/data/dbamon_ora_histread.txt";

$days = 2*365.24;

$s_time = time;

#######################################################################
# Customize Here:
# $dest_server = "ferrari";
# $dest_dir    = "/opt/dbasas/data/";
# $dest_user   = "border";
#######################################################################

$ENV{'ORACLE_SID'}  = $ORACLE_SID;
$ENV{'ORACLE_HOME'} = $ORACLE_HOME;
$old_path           = $ENV{"PATH"};
$ENV{'PATH'}        = "$ORACLE_HOME/bin:${old_path}";

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$mode = uc $ARGV[0];
$modelc = lc $mode;
if ($mode eq "") { $mode = "prod"; }

$modesuf = "_test" if $modelc eq "test"; 
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
chop($admin_email = `grep Admin_EMail: /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
#$arg5 = $ARGV[5];
#$arg6 = $ARGV[6];
#$arg7 = $ARGV[7];
#$arg8 = $ARGV[8];

if ($mode ne "test" && $mode ne "prod")
{
  print "$P | Usage: $0 {test | prod}\n";
  exit 1;
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  chop($admin_email = `grep 'Admin_EMail:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  &msg("Sending email notification to $admin_email");
  ##system("echo ' ' | mailx -m -s 'DBAmon | $P - Master=$hostname - $msg - sqlerror=$sqlerror - sqlcode=$sqlcode' $admin_email");
  system("echo '$DBI::errstr' | mailx -m -s 'DBAmon | $P - Master=$hostname - $msg' $admin_email");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  &msg("Selecting $what data");

  $statement  = "
    select 
      zdate,
      instance,
      dbms,
      category,
      parm,
      max(value) 
    from 
      dbamon.history
    where
      (dbamonmode = '${mode}' or dbamonmode = '${modelc}')
      and category = '$what'
      and ts >= sysdate - $days
    group by
      zdate,
      instance,
      dbms,
      category,
      parm
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error("Select_$what");
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $zdat = $Data[0];
    $inst = $Data[1];
    $dbms = $Data[2];
    $cat  = $Data[3];
    $parm = $Data[4];
    $val  = $Data[5];
    print DATA "$zdat $inst $dbms $cat $parm $val \n";
    ##print "DEBUG: $zdat $inst $dbms $cat $parm $val \n";
  }
  &msg("Selected $selectcount rows");
}

#-----------------------------------------------------------------------------
sub selectDataSPC
#-----------------------------------------------------------------------------
{
  $tmpfl = "/opt/dbasas/data/dbamon_ora_histread_SPC.txt";
  msg("Opening output DATA file: $tmpfl");
  system("rm $tmpfl 2>/dev/null");
  open(DATA, ">$tmpfl") || &error("Cannot open output $tmpfl - $!");

  $what = "'SPC','INS'"; 
  &msg("Selecting $what data");


  $statement  = "
    select 
      to_char(ts,\'YYYY.MM.DD HH24:MI:SS\'),
      instance,
      parm,
      dbms,
      value,
      value2,
      value3
    from 
      dbamon.history
    where
      (dbamonmode = '${mode}' or dbamonmode = '${modelc}')
      and category in ($what)
      and ts >= (sysdate - $days)
      -- and instance = 'ghrtest2_WEDBT2ME'
    order by
      1, 2
  ";
  &msg("DEBUG statement=$statement");
  $sth = $dbh->prepare($statement) || &error("Select_$what");
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $zdat    = $Data[0];
    $inst    = $Data[1];
    $ts      = $Data[2];
    $dbms    = $Data[3];
    $sizemb  = $Data[4];
    $usedmb  = $Data[5];
    $fstotsz = $Data[6];

    $inst =~ s/\_/\:/;

    print DATA "$zdat $inst $ts . $sizemb $usedmb $dbms $fstotsz \n";
  }
  &msg("Selected $selectcount rows - last zdat=$zdat");

  &msg("Closing DATA handle"); 
  close(DATA);
  system("ll /opt/dbasas/data/dbamon_ora_histread_SPC.txt 2>&1");
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  chop($hostname = `hostname`);
  chop($date = `date`);

  msg("Opening output DATA file: $tmpfl");
  system("rm $tmpfl 2>/dev/null");
  open(DATA, ">$tmpfl") || &error("Cannot open output $tmpfl - $!");
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");

##system("ln -s /opt/web/sas     /tmp/sas 2>&1");
##system("ln -s /opt/web/sasdata /tmp/sasdata 2>&1");

&connectDB;

&init;

$what = "STA"; &selectData; 
$what = "PER"; &selectData; 

&msg("Closing DATA handle"); 
close(DATA);
system("ll $tmpfl 2>&1");

&selectDataSPC; 

$elapsed_mins = int((time - $s_time) / 60); 

&msg("Done - $elapsed_mins Minutes");
exit 0;
