# -----------------------------------------------------------------------------
sub oraPerf
# -----------------------------------------------------------------------------
# Changes:
#   18Jan05 BB - Changed short text of bufhit event to contain percent
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if ($t_readhit[$thishost] eq "N")
  {
    &logit("(Not Selected (T_Read_Hit: is N)",$thishost);
    return 1;
  }

  if ($asmflag[$thishost])
  {
    &logit("(This check not applicable to +ASM instance)",$thishost);
    return 1;
  }

  #Default Thresholds
  $t_readhit[$thishost] = $df_t_db_cache_w if $t_readhit[$thishost] eq "";  
  $t_readhit_sev[$thishost] = "P" if $t_readhit_sev[$thishost] eq "";  

  if ($t_nuserproc_w[$thishost] eq "") { $t_nuserproc_w[$thishost] = $df_t_nuserproc_w }
  if ($t_nuserproc_c[$thishost] eq "") { $t_nuserproc_c[$thishost] = $df_t_nuserproc_c }

  $t_libhit  = 90;
  $t_dicthit = 90;

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  $oraperfok = 1;

  #---- Fix some vars - START
  $sga_size_mb[$thishost] = int($sga_size[$thishost] / 2**20); 
  if ($db_block_buffers[$thishost] > 0)
  {
    $bmeg = int(($db_block_buffers[$thishost] * $db_block_size[$thishost]) / 2**20);
    $bmsg = "db_block_buffers=$db_block_buffers[$thishost] (${bmeg}M)";
  }
  else
  {
    $bmeg = int($db_cache_size[$thishost] / 2**20);
    $bmsg = "db_cache_size=$db_cache_size[$thishost] (${bmeg}M)";
  }
  if ($bufhitratio_xr[$thishost] > $bufhitratio[$thishost]) 
  { 
    $this_bufhitratio = $bufhitratio_xr[$thishost]; 
  }
  else    
  { 
    $this_bufhitratio = $bufhitratio[$thishost]; 
  }
  $this_bufhitratio_int = int($this_bufhitratio);
  #---- Fix some vars - END

  ##print "bufblkgets=$bufblkgets[$thishost]\n";

  #---- redo events start

  if ($redo_1day_perhour[$thishost] > $df_redo_rate)
  {
    &event("P",$thishost,"Redo Log Switch Rate for the last 24 hours is $redo_1day_perhour[$thishost] Switches/Hour (Threshold=$df_redo_rate LogSize=$redo_log_size[$thishost]MB) - Excessive log switches are BAD for DB performance - Increase Online Redo Log size","RedoSwitchRate","DBA520");
  }
  if ($redo_archv_ratio[$thishost] > $df_redo_fs_ratio)
  {
    $z = int($df_redo_fs_ratio * $redo_30day_max_gb[$thishost] * 1.1);
    &event("P",$thishost,"Peak Last-30-Days Redo Rate ($redo_30day_max_gb[$thishost] GB) vs. Archivelog FS Size ($redo_archv_fs_gb[$thishost] GB)Ratio is $redo_archv_ratio[$thishost] (Threshold=$df_redo_fs_ratio) - Increase Archivelog FS Size to ${z} GB ","RedoArchFSSize","DBA521");
  }

  #---- redo events end

  if ($num_otrace[$thishost] > 0)
  {
    &event("C",$thishost,"$num_otrace[$thishost] ORACLE_HOME/otrace/admin/*.dat Files Found - OTRACE Is ON Which Causes Performance Problems","OTRACEO","DBA913");
    &debug($thishost,"$num_otrace[$thishost] ORACLE_HOME/otrace/admin/*.dat Files Found",1);
  }

  if ($bufblkgets[$thishost] =~ /^1844/ ||
      $bufblkgets[$thishost] =~ /^1.844/)
  {
    &logit("Buffer Block Gets ($bufblkgets[$thishost]) is invalid 1844* value (Oracle Bug) - Hit Ratio Not Applicable",$thishost);
    $oraperfok = 0; 
  }

  elsif ($bufcongets[$thishost] < 1000000)
  {
    &logit("Buffer Consistent Gets ($bufcongets[$thishost]) <1000000 - Hit Ratio Not Applicable",$thishost);
    $oraperfok = 0; 
  }

  elsif ($bufhitratio[$thishost] < 0 || $bufhitratio[$thishost] > 100)
  {
    &event("P",$thishost,"DB Cache Read Hit Ratio of $bufhitratio[$thishost] is invalid (< 0 or > 100)","BufHitNG","DBA911");
    &debug($thishost,"NG bufhitratio=$bufhitratio[$thishost] t=$t_readhit[$thishost]",1);
    $oraperfok = 0; 
  }

  #---- DB Cache read hit
  elsif ($this_bufhitratio < $t_readhit[$thishost])
  {
    &debug($thishost,"this_bufhitratio=$this_bufhitratio[$thishost] t_readhit=$t_readhit[$thishost]"); 
    if ($this_bufhitratio <= $df_t_db_cache_c) 
    {
      $zsev = "W"; 
    }
    else
    {
      $zsev = $t_readhit_sev[$thishost]; 
    }
    &event("$zsev",$thishost,"DB Cache Read Hit Ratio of $this_bufhitratio < threshold of $t_readhit[$thishost] (df_t_db_cache_c=$df_t_db_cache_c) - $bmsg","BufHit=${this_bufhitratio_int}%","DBA910");
    $oraperfok = 0; 
  }

  $timestamp_rowlimit = 100000;
  if ($timestamp_rows[$thishost] > $timestamp_rowlimit)
  {
    &event("C",$thishost,"DBAMON.TIMESTAMP Has > $timestamp_rowlimit rows ($timestamp_rows[$thishost])","TimeStampRows","DBA909");
    system("echo '' | dbamon_mailer -s 'DBAmon oraPerf() $titleraw[$thishost] DBAMON.TIMESTAMP has $timestamp_rows[$thishost] rows' $dbaon_debug") if -e "/tmp/dbamon_maildiag_flag.txt";
  }

  #---- See if mts is being used for non-rac DB
  ##print "mts_queue=$mts_queue[$thishost]\n";
  if ($ops[$thishost] ne "YES" && $mts_queue[$thishost] > 0)
  {
    &event("P",$thishost,"MTS is being used for this Non-RAC instance - Bad for performance - mts_queue=$mts_queue[$thishost]","MTSOn","DBA919");
  }

  #---- See if 9i+ and undo_mgmt not set to AUTO
  ##print "undo_mgmt=$undo_mgmt[$thishost]\n";
  if ($sw_version_num[$thishost] >= 9 && $undo_mgmt[$thishost] && uc $undo_mgmt[$thishost] ne "AUTO")
  {
    &event("C",$thishost,"UNDO_MANAGEMENT Is not set to AUTO - It should be - undo_mgmt=$undo_mgmt[$thishost]","UndoAutoOff","DBA925");
  }

  #---- See if compatible version is < dbms version 
  $this_compat = int($instance_parms[$thishost]{"COMPATIBLE"});
  $this_ver    = int($sw_version_num[$thishost]); 
  &debug($thishost,"COMPAT this_compat=$this_compat this_ver=$this_ver",1);
  if (this_compat > 0 && $this_compat < $this_ver)
  {
    &event("C",$thishost,"init.ora COMPATIBLE Version ($this_compat) is < DBMS software version ($this_ver)","CompatLow","DBA949");
  }

  #---- See if 9i+ and undo_mgmt not set to AUTO
  ##print "force_logging=$force_logging[$thishost]\n";
  if ($sw_version_num[$thishost] >= 9 && uc $force_logging[$thishost] eq "NO")
  {
    &event("C",$thishost,"FORCE LOGGING Should be turned on - force_logging=$force_logging[$thishost]","ForceLogOff","DBA926");
  }

  #---- See if 9i+ and undo_mgmt not set to AUTO
  ##print "sys_analyzed=$sys_analyzed[$thishost]\n";
  if ($sw_version_num[$thishost] < 10 && $sys_analyzed[$thishost] > 0)
  {
    &event("W",$thishost,"$sys_analyzed[$thishost] Dictionary Objects have been ANALYZED - This is bad for performance","DictAnalyzed","DBA927");
  }

  if ($sql_trace[$thishost] eq "TRUE")
  {
    &event("C",$thishost,"Instance-Wide SQL_TRACE is set to $sql_trace[$thishost] - This Causes Performance Problems","SQLTraceOn","DBA914");
  }

  if ($libhitratio[$thishost] < $t_libhit && $libgets[$thishost] > 1000000)
  {
    &event("P",$thishost,"Library Cache Hit Ratio is $libhitratio[$thishost]% (Should Be >= 90%) - SGA Size: $sga_size_mb[$thishost]M - Increase shared_pool_size","LibHitRatio","DBA921");
  }

  if ($rollback_wtg[$thishost] >= 1)
  {
    &event("P",$thishost,"Rollback Segment Header Waits Are $rollback_wtg[$thishost]% of Gets (Gets/Waits Ratio > 1.00%) - Add Rollback Segments","RBHdrWaits","DBA923");
  }

  if ($dicthitratio[$thishost] < $t_dicthit && $dictgets[$thishost] > 1000000)
  {
    &event("P",$thishost,"Dictionary Cache Hit Ratio is $dicthitratio[$thishost]% (Should Be >= 90%) - SGA Size: $sga_size_mb[$thishost]M - Increase shared_pool_size","LibHitRatio","DBA922");
  }

  ##print "oraPerf - $titleraw[$thishost] fb=$free_buffers[$thishost]\n";
  if ($free_buffers[$thishost] > -1 && $free_buffers[$thishost] < 10 && $sw_version_num[$thishost] < 10)
  {
    &event("P",$thishost,"There are fewer than 10 Free DB Cache Buffers (free_buffers=$free_buffers[$thishost]) - It would be beneficial to increase DB Cache Size - $bmsg","NoFreeBuffers","DBA924");
  }

  ##print "oraPerf - $titleraw[$thishost] gs=$granule_size[$thishost] dcs=$db_cache_size[$thishost]\n";
  if ($granule_size[$thishost] > 0 && $granule_size[$thishost] == $db_cache_size[$thishost])
  {
    &event("C",$thishost,"DB Cache is only 1 granule in size - It was probably underspecified - granule_size=$granule_size[$thishost] db_cache_size=$db_cache_size[$thishost]","1GranuleCache","DBA928");
  }

  $hw_memory_threshold_w = 95;
  $hw_memory_threshold_c = 99;
  ##print "oraPerf - $titleraw[$thishost] gs=$hw_memory_pct_full[$thishost]\n";
  if ($hw_memory_free[$thishost] ne "" && $hw_memory_pct_full[$thishost] >= $hw_memory_threshold_w)
  {
    if ($hw_memory_pct_full[$thishost] >= $hw_memory_threshold_c) { $zsev = "W"; } 
    else                                                          { $zsev = "P"; }
    $zpct = int($hw_memory_pct_full[$thishost]);
    &event("$zsev",$thishost,"Server Memory is $hw_memory_pct_full[$thishost] used (t=$hw_memory_threshold_w/$hw_memory_threshold_c physmem=$hw_memory_size_gb[$thishost](gB) memfree=$hw_memory_free[$thishost](gB))","SrvrMem${zpct}%","DBA929");
  }

  #
  # Process user exceptions
  #

  $user_exceptions[$thishost] =~ s/\$/\\\$/g;

  ##print "perf ue=$user_exceptions[$thishost]\n";
  @words= split(/ /,$user_exceptions[$thishost]);
  ## print "#words=$#words\n";

  $dfltsys_list = "";
  $dfltsys_sql  = "";
  $dfltsys_cnt  = 0;
  $tempsys_list = "";
  $tempsys_sql  = "";
  $tempsys_cnt  = 0;
  $tempperm_list = "";
  $tempperm_sql  = "";
  $tempperm_cnt  = 0;

  foreach (@words)
  {
    #split this entry
    @subwords= split(/,/,$_);
    ##print "#subwords=$#subwords\n";
    $verb = $subwords[0];
    $user = $subwords[1];
    $dfts = $subwords[2];
    $tmts = $subwords[3];
    ##print "verb=$verb user=$user dfts=$dfts tmts=$tmts\n";

    if ($verb eq "DFLT_SYS:") 
    {
      $dfltsys_list .= "User Exception: User=$user Default_Tablespace=$dfts Temporary_Tablespace=$tmts\n";
      $dfltsys_cnt++;
      $sql = "ALTER USER $user DEFAULT TABLESPACE $good_users_ts[$thishost];";
      $dfltsys_sql  .= "$sql\n";
    }
    if ($verb eq "TEMP_SYS:") 
    {
      $tempsys_list .= "User Exception: User=$user Default_Tablespace=$dfts Temporary_Tablespace=$tmts\n";
      $tempsys_cnt++;
      $sql = "ALTER USER $user TEMPORARY TABLESPACE $good_temp_ts[$thishost];";
      $tempsys_sql  .= "$sql\n";
    }
    if ($verb eq "TEMP_PERM:") 
    {
      $tempperm_list .= "User Exception: User=$user Default_Tablespace=$dfts Temporary_Tablespace=$tmts\n";
      $tempperm_cnt++;
      $sql = "ALTER USER $user TEMPORARY TABLESPACE $good_temp_ts[$thishost];";
      $tempperm_sql  .= "$sql\n";
    }
  }
  
  if ($dfltsys_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $dfltsys_list;
    print TMPFL6 "SQL To Fix: \n<b>$dfltsys_sql\n</b>";
    close(TMPFL6);
    &event("W",$thishost,"$dfltsys_cnt DB Users Found With DEFAULT TABLESPACE Set To SYSTEM","UsersDfltSys","DBA915",$tmpfl6);
  }

  if ($tempsys_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $tempsys_list;
    print TMPFL6 "SQL To Fix: \n<b>$tempsys_sql\n</b>";
    close(TMPFL6);
    &event("W",$thishost,"$tempsys_cnt DB Users Found With TEMPORARY TABLESPACE Set To SYSTEM","UsersTempSys","DBA916",$tmpfl6);
  }

  if ($tempperm_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $tempperm_list;
    print TMPFL6 "SQL To Fix: \n<b>$tempperm_sql\n</b>";
    close(TMPFL6);
    &event("W",$thishost,"$tempperm_cnt DB Users Found Whose TEMPORARY TABLESPACE Is a PERMANENT Tablespace","UsersTempPerm","DBA917",$tmpfl6);
  }

  if ($df_temp_ts[$thishost] eq "SYSTEM")
  {
    &event("C",$thishost,"The instance default TEMP tablespace is set to SYSTEM - Could cause performance problems","DFTSSystem","DBA930");
  }

  if ($df_perm_ts[$thishost] eq "SYSTEM")
  {
    &event("C",$thishost,"The instance default PERM tablespace is set to SYSTEM - Could cause performance problems","DFTSSystem","DBA930");
  }

  #
  # Process ts exceptions
  #

  ##print "perf ue=$ts_exceptions[$thishost]\n";
  @words= split(/ /,$ts_exceptions[$thishost]);
  ## print "#words=$#words\n";

  $tempperm_list = "";
  $tempperm_cnt  = 0;

  foreach (@words)
  {
    #split this entry
    @subwords= split(/,/,$_);
    ##print "#subwords=$#subwords\n";
    $verb = $subwords[0];
    $ts   = $subwords[1];
    $t1   = $subwords[2];
    $t2   = $subwords[3];
    ##print "verb=$verb ts=$ts \n";

    if ($verb eq "TEMP_PERM:") 
    {
      $tempperm_list .= "Tablespace=$ts \n";
      $tempperm_cnt++;
    }
  }
  
  if ($tempperm_list ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $tempperm_list;
    close(TMPFL6);
    &event("C",$thishost,"TEMP Tablespace is a PERMANENT Tablespace (It Should Be TEMPORARY)","TSTempPerm","DBA920",$tmpfl6);
  }

  #---- User audit START
  $t1_numusers = 50; 
  $t2_numusers = 200; 
  $t3_numusers = 1000; 

  if ($numusers[$thishost] >= $t3_numusers)
  {
    #&event("N",$thishost,"DBA_USERS User Count of $numusers[$thishost] meets or exceeds threshold ($t3_numusers)","UserCnt3","DBA937");
  }
  if ($numusers[$thishost] >= $t2_numusers)
  {
    #&event("N",$thishost,"DBA_USERS User Count of $numusers[$thishost] meets or exceeds threshold ($t2_numusers)","UserCnt2","DBA936");
  }
  if ($numusers[$thishost] >= $t1_numusers)
  {
    #&event("N",$thishost,"DBA_USERS User Count of $numusers[$thishost] meets or exceeds threshold ($t1_numusers)","UserCnt1","DBA935");
  }

  if ($numprofs[$thishost] > 0)
  {
    &event("N",$thishost,"DBA_PROFILES - $numprofs[$thishost] Non-Default Profiles Defined","ProfCnt","DBA938");
  }
  if ($numusersnd[$thishost] > 0)
  {
    &event("N",$thishost,"DBA_USERS - $numusersnd[$thishost] Users using Non-DEFAULT Profile","UserProf","DBA939");
  }
  #---- User audit END

  #---- Complex PWs info event
  if ($complexpw[$thishost] eq "ON")
  {
    &event("N",$thishost,"Complex DB User Passwords Enforced - DB Created $dbcreatedate[$thishost]","ComplexPW","DBA934");
  }

  $nf_t_c = 90;
  $nf_t_w = 80;

  if ($nf_pct[$thishost] >= $nf_t_c)
  {
    $msg = sprintf("UX NFILEs %s%% Used - Current Value=%s Kernel Maximum=%s (Critical Threshold=$nf_t_c%%)",$nf_pct[$thishost],$nf_cur[$thishost],$nf_max[$thishost]);
    &event("C",$thishost,"$msg","NFile","DBA461");
    &debug($thishost,"C nf_pct=$nf_pct[$thishost]",1);
  }
  elsif ($nf_pct[$thishost] >= $nf_t_w)
  {
    $msg = sprintf("UX NFILEs %s%% Used - Current Value=%s Kernel Maximum=%s (Warning Threshold=$nf_t_w%%)",$nf_pct[$thishost],$nf_cur[$thishost],$nf_max[$thishost]);
    &event("W",$thishost,"$msg","NFile","DBA461");
    &debug($thishost,"W nf_pct=$nf_pct[$thishost]",1);
  }
  else
  {
    $msg = sprintf("OK - %s / %s %s%%",$nf_cur[$thishost],$nf_max[$thishost],$nf_pct[$thishost]);
    &logit($msg,$thishost);
  }

  if ($os_nuserproc_pct[$thishost] > 0) 
  {
    &debug($thishost, "UX NUSERPROC (HP-UX maxuprc Kernel Value) $os_nuserproc_pct[$thishost]% Used - MAXUPRC=$os_maxuprc[$thishost] OSUserProcCount=$os_nuserproc[$thishost] (Thresholds: $t_nuserproc_w[$thishost]%/$t_nuserproc_c[$thishost]%)");

    #if ($$os_nuserproc[$thishost] = $F3;
    #758        $os_maxuprc[$thishost] = $F4;
    #759        $os_nuserproc_pct[$thishost] = $F5;
    #$df_t_nuserproc_w = $words[0];
    # 131            $df_t_nuserproc_c = $words[1];

    $msg = "UX NUSERPROC (HP-UX maxuprc Kernel Value) $os_nuserproc_pct[$thishost]% Used - MAXUPRC=$os_maxuprc[$thishost] OSUserProcCount=$os_nuserproc[$thishost] (Thresholds: $t_nuserproc_w[$thishost]%/$t_nuserproc_c[$thishost]%)";

    if    ($os_nuserproc_pct[$thishost] >= $t_nuserproc_c[$thishost] && $t_nuserproc_c[$thishost] > 0)
    {
      &event("C",$thishost,"$msg","NUserProc","DBA932");
      &debug($thishost,"$titleraw[$thishost] C os_nuserproc_pct=$os_nuserproc_pct[$thishost]",1,$tmpfl6); 
    }
    elsif ($os_nuserproc_pct[$thishost] >= $t_nuserproc_w[$thishost])
    {
      &event("W",$thishost,"$msg","NUserProc","DBA932");
      &debug($thishost,"$titleraw[$thishost] W os_nuserproc_pct=$os_nuserproc_pct[$thishost]",1,$tmpfl6); 
    }
    else
    {
      $msg = sprintf("OK - NUSERPROC_pct=$os_nuserproc_pct[$thishost] (Thresholds: $t_nuserproc_w[$thishost]%/$t_nuserproc_c[$thishost]%)");
      &logit($msg,$thishost);
    }
  }

  # Make D page
  &logDetails($thishost,"</pre><hr>");
  &logDetails($thishost,"<h3>Oracle Performance Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");

  &logDetails($thishost,"<tr><td>$f_s<b>Buffer Cache Hit Ratio:<td align=right>$f_s $bufhitratio[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Buffer Cache Hit Ratio (Excluding RECYCLE Pool):<td align=right>$f_s $bufhitratio_xr[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Library Cache Hit Ratio:<td align=right>$f_s $libhitratio[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Library Cache Gets:<td align=right>$f_s $libgets[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Dictionary Cache Hit Ratio:<td align=right>$f_s $dicthitratio[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Dictionary Cache Gets:<td align=right>$f_s $dictgets[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Consistent Gets:<td align=right>$f_s $bufcongets[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Buffer Block Gets:<td align=right>$f_s $bufblkgets[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Buffer Physical Reads:<td align=right>$f_s $bufphysreads[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>db_block_buffers:<td align=right>$f_s $db_block_buffers[$thishost] <td>$f_s (8i & Lower)");
  &logDetails($thishost,"<tr><td>$f_s<b>db_cache_size:<td align=right>$f_s $db_cache_size[$thishost] <td>$f_s (9i & Higher))");
  &logDetails($thishost,"<tr><td>$f_s<b>Free DB Cache Buffers:<td align=right>$f_s $free_buffers[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>DEFAULT Pool Hit Ratio:<td align=right>$f_s $pool_default_hr[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>RECYCLE Pool Hit Ratio:<td align=right>$f_s $pool_recycle_hr[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>KEEP Pool Hit Ratio:<td align=right>$f_s $pool_keep_hr[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Number of OTRACE .dat Files:<td align=right>$f_s $num_otrace[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Instance SQL_TRACE Setting:<td align=right>$f_s $sql_trace[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Rollback Segment Waits/Gets Ratio:<td align=right>$f_s $rollback_wtg[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>NFILE Current Value:<td align=right>$f_s $nf_cur[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>NFILE Maximum Value:<td align=right>$f_s $nf_max[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>NFILE % Used:<td align=right>$f_s $nf_pct[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>MTS Queue Count:<td align=right>$f_s $mts_queue[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Undo Management:<td align=right>$f_s $undo_mgmt[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s<b>Force Logging:<td align=right>$f_s $force_logging[$thishost]");
  &logDetails($thishost,"</table><hr>");

  if ($oraperfok)
  {
    &logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
